;=========================================================================
; Bitmap from file demo, modal dialog as main.
;
; This source is dependent on the on the sample
; bitmap created by create_sample_bitmap.asm.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

IDC_BM equ 101

;=========================================================================
.data
    dtuX dd 0
    dtuY dd 0
    hbmp dd 0
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL rc:RECT

    SWITCH uMsg

      CASE WM_INITDIALOG

        ;------------------------------------------------------
        ; Adjust the client area to 300x300 pixels, precisely.
        ;------------------------------------------------------

        invoke SetClientSize, hwndDlg, 300, 300

        ;-----------------------------------------------------------
        ; Load the sample bitmap from its file and save the handle.
        ;-----------------------------------------------------------

        invoke LoadImage, NULL, chr$("sample.bmp"),
                          IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE
        mov hbmp, eax

        ;-------------------------------------------------
        ; Get the handle for the SS_BITMAP static control
        ; and load the bitmap into the control.
        ;-------------------------------------------------

        invoke GetDlgItem, hwndDlg, IDC_BM
        invoke SendMessage, eax, STM_SETIMAGE, IMAGE_BITMAP, hbmp

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDCANCEL

            ;--------------------
            ; Clean up and exit.
            ;--------------------

            invoke DeleteObject, hbmp
            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        ;--------------------
        ; Clean up and exit.
        ;--------------------

        invoke DeleteObject, hbmp
        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    ;---------------------------------------------------------------
    ; Get a width and height in DTUs that will size the client area
    ; close to the specified pixel width and height, regardless of
    ; the system font settings.
    ;---------------------------------------------------------------

    invoke ClientPixelWidthToDialogWidth, 300
    mov dtuX, eax
    invoke ClientPixelHeightToDialogHeight, 300
    mov dtuY, eax

    invoke DefineDialog, chr$("Bitmap From File Demo"),
                         WS_OVERLAPPED or WS_SYSMENU \
                         or DS_CENTER,
                         0, 0, dtuX, dtuY,
                         0, 0,
                         1

    invoke DefineBitmap, 0, 0, 0, 0, IDC_BM

    invoke CreateModalDialog, 0, ADDR DialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
