;=========================================================================
; Bitmap from resource demo, modal dialog as main.
;
; This source is dependent on the resource definition
; bitmap_from_res.rc, the resource compiler, and the
; linker to include the bitmap resource in the EXE.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

IDC_BM equ 101

;=========================================================================
.data
    dtuX dd 0
    dtuY dd 0
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_INITDIALOG

        ;------------------------------------------------------
        ; Adjust the client area to 300x300 pixels, precisely.
        ;------------------------------------------------------

        invoke SetClientSize, hwndDlg, 300, 300

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    ;---------------------------------------------------------------
    ; Get a width and height in DTUs that will size the client area
    ; close to the specified pixel width and height, regardless of
    ; the system font settings.
    ;---------------------------------------------------------------

    invoke ClientPixelWidthToDialogWidth, 300
    mov dtuX, eax
    invoke ClientPixelHeightToDialogHeight, 300
    mov dtuY, eax

    invoke DefineDialog, chr$("Bitmap From Resource Demo"),
                         WS_OVERLAPPED or WS_SYSMENU \
                         or DS_CENTER,
                         0, 0, dtuX, dtuY,
                         0, 0,
                         1

    ;------------------------------------------------------------------
    ; Here the bitmap resource is specified by the resource ID and the
    ; system loads the bitmap into the SS_BITMAP static control.
    ;------------------------------------------------------------------

    invoke DefineBitmap, 0, 0, 0, 1000, IDC_BM

    invoke CreateModalDialog, 0, ADDR DialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
