;=========================================================================
; Control grouping demo, modal dialog as main.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

IDC_RADIO1  equ 101
IDC_RADIO2  equ 102
IDC_RADIO3  equ 103
IDC_RADIO4  equ 104
IDC_BTNGET  equ 105
IDC_GROUP1  equ 106
IDC_GROUP2  equ 107

;=========================================================================
.data
    state db 5 dup(0)
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDC_BTNGET

            push ebx
            mov ebx, IDC_RADIO1
            .WHILE ebx <= IDC_RADIO4
              invoke IsDlgButtonChecked, hwndDlg, ebx
              mov ecx, ebx
              sub ecx, IDC_RADIO1
              .IF eax == BST_CHECKED
                mov state[ecx], '1'
              .ELSE
                mov state[ecx], '0'
              .ENDIF
              inc ebx
            .ENDW
            pop ebx

            invoke MessageBox, hwndDlg, ADDR state, chr$("State"), 0

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    invoke DefineDialog, chr$("Group Demo"),
                         WS_OVERLAPPED or WS_SYSMENU \
                         or DS_CENTER,
                         0, 0, 150, 100,
                         0, 0,
                         8

    invoke DefineGroupBox, chr$("GroupBox1"),
                           0,
                           10, 5, 80, 35,
                           IDC_GROUP1

    ;----------------------------------------------------------------
    ; By default all of the controls in a dialog form a single group.
    ; The WS_GROUP style specifies the first control in a group, with
    ; the group extending up to, but not including, the next control
    ; in the tab order that has the WS_GROUP style.
    ;----------------------------------------------------------------

    invoke DefineAutoRadioButton, chr$("AutoRadioButton&1"),
                                  WS_TABSTOP or WS_GROUP,
                                  15, 15, 70, 10,
                                  IDC_RADIO1

    invoke DefineAutoRadioButton, chr$("AutoRadioButton&2"),
                                  0,
                                  15, 25, 70, 10,
                                  IDC_RADIO2

    invoke DefineGroupBox, chr$("GroupBox2"),
                           0,
                           10, 45, 80, 35,
                           IDC_GROUP2

    invoke DefineAutoRadioButton, chr$("AutoRadioButton&3"),
                                  WS_TABSTOP or WS_GROUP,
                                  15, 55, 70, 10,
                                  IDC_RADIO3

    invoke DefineAutoRadioButton, chr$("AutoRadioButton&4"),
                                  0,
                                  15, 65, 70, 10,
                                  IDC_RADIO4

    invoke DefineDefPushButton, chr$("&Get State"),
                                WS_TABSTOP or WS_GROUP,
                                100, 10, 38, 12,
                                IDC_BTNGET

    invoke DefinePushButton, chr$("Cancel"),
                             WS_TABSTOP,
                             100, 28, 38, 12,
                             IDCANCEL

    invoke CreateModalDialog, 0, ADDR DialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
