;=========================================================================
; Basic framework for a modal dialog from an in-memory template.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

;=========================================================================
.data
    hwndBtn HWND 0
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL rcDlg:RECT
    LOCAL ps:PAINTSTRUCT

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hwndDlg, IDCANCEL
        mov hwndBtn, eax

      CASE WM_CTLCOLORDLG

        ;------------------------------------------
        ; Set the client area background to white.
        ;------------------------------------------

        invoke GetStockObject, WHITE_BRUSH
        ret

      CASE WM_SIZE

        invoke GetClientRect, hwndDlg, ADDR rcDlg

      CASE WM_PAINT

        invoke BeginPaint, hwndDlg, ADDR ps
        invoke EndPaint, hwndDlg, ADDR ps

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    invoke DefineDialog, chr$("Title"),
                         WS_OVERLAPPEDWINDOW or DS_CENTER,
                         0, 0, 100, 75,
                         0, 0,
                         1

    invoke DefineDefPushButton, chr$("Close"), 0, 35, 50, 30, 10, IDCANCEL

    invoke CreateModalDialog, 0, ADDR DialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
