;=========================================================================
; Status bar demo, modal dialog as main.
;=========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

IDC_SB equ 101

;=========================================================================
.data
    hwndSB  HWND  0
    widths  dd    4   dup(0)
    szPart0 db    20  dup(0)
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL sbHeight  :DWORD
    LOCAL rcDlg     :RECT
    LOCAL rcSB      :RECT

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hwndDlg, IDC_SB
        mov hwndSB, eax

        ;----------------------------------------------------------
        ; Calculate the coordinates of the right edge of each part
        ; and load the values into the widths array. Each part
        ; occupies 1/4 of the intial width of the client area.
        ;----------------------------------------------------------

        invoke GetClientRect, hwndDlg, ADDR rcDlg
        mov eax, rcDlg.right
        shr eax, 2
        mov edx, eax
        mov widths[0], eax      ; right edge = rcDlg.right / 4
        add eax, eax
        mov widths[4], eax      ; right edge = (rcDlg.right / 4) * 2
        add eax, edx
        mov widths[8], eax      ; right edge = (rcDlg.right / 4) * 3
        mov widths[12], -1      ; right edge extends to window border

        ;------------------------------------------------
        ; Set the number of parts and the coordinates of
        ; the right of each part.
        ;------------------------------------------------

        invoke SendMessage, hwndSB, SB_SETPARTS, 4, ADDR widths

      CASE WM_SIZE

        ;------------------------------------------
        ; Move the status bar as necessary to keep
        ; it at the lower edge of the window.
        ;------------------------------------------

        invoke GetClientRect, hwndDlg, ADDR rcDlg
        invoke GetWindowRect, hwndSB, ADDR rcSB
        mov eax, rcSB.bottom
        sub eax, rcSB.top
        inc eax
        mov sbHeight, eax
        mov edx, rcDlg.bottom
        sub edx, sbHeight
        mov eax, lParam
        and eax, 0ffffh
        invoke MoveWindow, hwndSB, 0, edx, eax, edx, FALSE

        ;-----------------------------------------------
        ; The length of szPart0 must effectively be set
        ; to zero before each round of concatenation.
        ;-----------------------------------------------

        mov szPart0, 0

        ;-----------------------------
        ; Assemble the part 0 string.
        ;-----------------------------

        invoke szCat, ADDR szPart0, str$(rcDlg.right)
        invoke szCat, ADDR szPart0, chr$("x")
        invoke szCat, ADDR szPart0, str$(rcDlg.bottom)

        ;-----------------------------
        ; Set the text for each part.
        ;-----------------------------

        invoke SendMessage, hwndSB, SB_SETTEXT, 0, ADDR szPart0
        invoke SendMessage, hwndSB, SB_SETTEXT, 1, chr$("Part 1")
        invoke SendMessage, hwndSB, SB_SETTEXT, 2, chr$("Part 2")
        invoke SendMessage, hwndSB, SB_SETTEXT, 3, chr$("Part 3")

        ;--------------------------------------------------
        ; Add the client area, less the status bar, to the
        ; update region so it will be repainted.
        ;--------------------------------------------------

        mov eax, sbHeight
        sub rcDlg.bottom, eax
        invoke InvalidateRect, hwndDlg, ADDR rcDlg, TRUE

      CASE WM_COMMAND

        SWITCH loword(wParam)

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, NULL

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    invoke InitializeCommonControls

    invoke DefineDialog, chr$("Status Bar Demo"),
                         WS_OVERLAPPEDWINDOW or DS_CENTER,
                         0, 0, 120, 90,
                         0, 0,
                         1

    ;------------------------------------------------------------------
    ; For controls that will be sized in the WM_SIZE handler, instead
    ; of trying to anticipate the position and/or size, just use zeros
    ; and set the correct values in the WM_SIZE handler.
    ;------------------------------------------------------------------

    invoke DefineControl, chr$("msctls_statusbar32"), 0,
                          WS_CHILD or WS_VISIBLE or \
                          0,
                          0, 0, 0, 0,
                          0, IDC_SB

    invoke CreateModalDialog, 0, ADDR DialogProc, 0

    invoke ExitProcess, 0

;=========================================================================

end start
