;========================================================================
; Toolbar demo, with tooltips, modeless dialog as main.
;========================================================================

include \GeneSys\include\GeneSysRt.inc
include \GeneSys\macros\macros.asm
include xmacros.asm
include imdialog.asm
include support.asm

IDC_TB    equ 101
IDS_NEW   equ 200
IDS_OPEN  equ 201
IDS_SAVE  equ 202
IDS_CUT   equ 203
IDS_COPY  equ 204
IDS_PASTE equ 205

;=========================================================================
.data
    hDlg    HWND        0
    hwndTB  HWND        0
    hTT     HANDLE      0
    tbb     TBBUTTON    7 dup(<>)
    msg     MSG         <>
    tbab    TBADDBITMAP <>
.code
;=========================================================================

DialogProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hwndDlg, IDC_TB
        mov hwndTB, eax

        ;--------------------------------------------------------
        ; Specify the structure size so the system can determine
        ; which version of the common control DLL is being used.
        ;--------------------------------------------------------

        invoke SendMessage, hwndTB, TB_BUTTONSTRUCTSIZE,
                            SIZEOF TBBUTTON, 0

        ;----------------------------------------------------
        ; Add the system-defined bitmap button images to the
        ; list of available images.
        ;----------------------------------------------------

        mov tbab.hInst, HINST_COMMCTRL
        mov tbab.nID, IDB_STD_LARGE_COLOR
        ;mov tbab.nID, IDB_STD_SMALL_COLOR
        ;mov tbab.nID, IDB_VIEW_LARGE_COLOR
        ;mov tbab.nID, IDB_VIEW_SMALL_COLOR

        invoke SendMessage, hwndTB, TB_ADDBITMAP, 0, ADDR tbab

        ;------------------------------------------------------
        ; For each button, specify the button image index, the
        ; associated command identifier, and the button state
        ; and style. Note that this code depends on the unused
        ; members of the TBBUTTON structure being initialized
        ; to zero.
        ;------------------------------------------------------

        mov tbb[0*SIZEOF TBBUTTON].iBitmap, STD_FILENEW
        mov tbb[0*SIZEOF TBBUTTON].idCommand, IDS_NEW
        mov tbb[0*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[0*SIZEOF TBBUTTON].fsStyle, TBSTYLE_BUTTON
        mov tbb[1*SIZEOF TBBUTTON].iBitmap, STD_FILEOPEN
        mov tbb[1*SIZEOF TBBUTTON].idCommand, IDS_OPEN
        mov tbb[1*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[1*SIZEOF TBBUTTON].fsStyle, TBSTYLE_BUTTON
        mov tbb[2*SIZEOF TBBUTTON].iBitmap, STD_FILESAVE
        mov tbb[2*SIZEOF TBBUTTON].idCommand, IDS_SAVE
        mov tbb[2*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[2*SIZEOF TBBUTTON].fsStyle, TBSTYLE_BUTTON
        mov tbb[3*SIZEOF TBBUTTON].iBitmap, 0
        mov tbb[3*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[3*SIZEOF TBBUTTON].fsStyle, TBSTYLE_SEP
        mov tbb[4*SIZEOF TBBUTTON].iBitmap, STD_CUT
        mov tbb[4*SIZEOF TBBUTTON].idCommand, IDS_CUT
        mov tbb[4*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[4*SIZEOF TBBUTTON].fsStyle, TBSTYLE_BUTTON
        mov tbb[5*SIZEOF TBBUTTON].iBitmap, STD_COPY
        mov tbb[5*SIZEOF TBBUTTON].idCommand, IDS_COPY
        mov tbb[5*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[5*SIZEOF TBBUTTON].fsStyle, TBSTYLE_BUTTON
        mov tbb[6*SIZEOF TBBUTTON].iBitmap, STD_PASTE
        mov tbb[6*SIZEOF TBBUTTON].idCommand, IDS_PASTE
        mov tbb[6*SIZEOF TBBUTTON].fsState, TBSTATE_ENABLED
        mov tbb[6*SIZEOF TBBUTTON].fsStyle, TBSTYLE_BUTTON

        ;---------------------------------
        ; Add the buttons to the toolbar.
        ;---------------------------------

        invoke SendMessage, hwndTB, TB_ADDBUTTONS, 7, ADDR tbb
        invoke SendMessage, hwndTB, TB_AUTOSIZE, 0, 0

        ;------------------------------------------------------------
        ; Get and save the handle to the ToolTip control associated
        ; with the toolbar (see the TBSTYLE_TOOLTIPS documentation).
        ;------------------------------------------------------------

        invoke SendMessage, hwndTB, TB_GETTOOLTIPS, 0, 0
        mov hTT, eax

      CASE WM_COMMAND

        SWITCH loword(wParam)
          CASE IDS_NEW
            invoke MessageBox, hwndDlg, chr$("New"), chr$(" ") , 0
          CASE IDS_OPEN
            invoke MessageBox, hwndDlg, chr$("Open"), chr$(" ") , 0
          CASE IDS_SAVE
            invoke MessageBox, hwndDlg, chr$("Save"), chr$(" ") , 0
          CASE IDS_CUT
            invoke MessageBox, hwndDlg, chr$("Cut"), chr$(" ") , 0
          CASE IDS_COPY
            invoke MessageBox, hwndDlg, chr$("Copy"), chr$(" ") , 0
          CASE IDS_PASTE
            invoke MessageBox, hwndDlg, chr$("Paste"), chr$(" ") , 0
          CASE IDCANCEL
            invoke DestroyWindow, hwndDlg
        ENDSW

      CASE WM_NOTIFY

        push ebx
        mov ebx, lParam
        mov eax, hTT
        .IF [ebx].NMHDR.hwndFrom == eax
          .IF [ebx].NMHDR.code == TTN_GETDISPINFO

            ;----------------------------------------------------
            ; We now know that lParam is actually a pointer to a
            ; NMTTDISPINFO structure, and the ToolTip control is
            ; requesting information that it needs to display a
            ; tooltip. Note that the hdr member of the structure
            ; is a NMHDR structure.
            ;----------------------------------------------------

            SWITCH [ebx].NMTTDISPINFO.hdr.idFrom
              CASE IDS_NEW
                mov [ebx].NMTTDISPINFO.lpszText, chr$("New")
              CASE IDS_OPEN
                mov [ebx].NMTTDISPINFO.lpszText, chr$("Open")
              CASE IDS_SAVE
                mov [ebx].NMTTDISPINFO.lpszText, chr$("Save")
              CASE IDS_CUT
                mov [ebx].NMTTDISPINFO.lpszText, chr$("Cut")
              CASE IDS_COPY
                mov [ebx].NMTTDISPINFO.lpszText, chr$("Copy")
              CASE IDS_PASTE
                mov [ebx].NMTTDISPINFO.lpszText, chr$("Paste")
            ENDSW

            ;-------------------------------------------
            ; This causes the ToolTip control to retain
            ; the information after the first request.
            ;-------------------------------------------

            or [ebx].NMTTDISPINFO.uFlags, TTF_DI_SETITEM

          .ENDIF
        .ENDIF
        pop ebx

      CASE WM_CLOSE

        invoke DestroyWindow, hwndDlg

      CASE WM_DESTROY

        invoke PostQuitMessage, NULL

    ENDSW

    xor eax, eax
    ret

DialogProc endp

;=========================================================================
start:
;=========================================================================

    invoke InitializeCommonControls

    invoke DefineDialog, chr$("Toolbar Demo"),
                         WS_OVERLAPPEDWINDOW or \
                         WS_VISIBLE or DS_CENTER,
                         0, 0, 120, 90,
                         0, 0,
                         1

    invoke DefineControl, chr$("ToolbarWindow32"), 0,
                          WS_CHILD or WS_VISIBLE or \
                          TBSTYLE_TOOLTIPS or TBSTYLE_FLAT,
                          0, 0, 0, 0,
                          0, IDC_TB

    invoke CreateModelessDialog, 0, ADDR DialogProc, 0
    mov hDlg, eax

  msgLoop:

    invoke GetMessage, ADDR msg, 0, 0, 0
    .IF eax != 0
      invoke IsDialogMessage, hDlg, ADDR msg
      .IF eax == 0
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
      .ENDIF
      jmp msgLoop
    .ENDIF

    invoke ExitProcess, eax

;=========================================================================

end start
